> ## Documentation Index
> Fetch the complete documentation index at: https://docs.near.org/llms.txt
> Use this file to discover all available pages before exploring further.

# View Contract Code

> Returns the contract code (Wasm binary) deployed to the account.



## OpenAPI

````yaml /openapi.json post /EXPERIMENTAL_view_code
openapi: 3.0.0
info:
  title: NEAR Protocol JSON RPC API
  version: 1.2.3
servers:
  - url: https://rpc.mainnet.near.org
    description: Mainnet
  - url: https://rpc.testnet.near.org
    description: Testnet
security: []
paths:
  /EXPERIMENTAL_view_code:
    post:
      summary: View Contract Code
      description: Returns the contract code (Wasm binary) deployed to the account.
      operationId: EXPERIMENTAL_view_code
      requestBody:
        content:
          application/json:
            schema:
              $ref: '#/components/schemas/JsonRpcRequest_for_EXPERIMENTAL_view_code'
        required: true
      responses:
        '200':
          description: ''
          content:
            application/json:
              schema:
                $ref: >-
                  #/components/schemas/JsonRpcResponse_for_RpcViewCodeResponse_and_RpcViewCodeError
components:
  schemas:
    JsonRpcRequest_for_EXPERIMENTAL_view_code:
      properties:
        id:
          type: string
        jsonrpc:
          type: string
        method:
          enum:
            - EXPERIMENTAL_view_code
          type: string
        params:
          $ref: '#/components/schemas/RpcViewCodeRequest'
      required:
        - jsonrpc
        - id
        - params
        - method
      title: JsonRpcRequest_for_EXPERIMENTAL_view_code
      type: object
    JsonRpcResponse_for_RpcViewCodeResponse_and_RpcViewCodeError:
      oneOf:
        - $ref: >-
            #/components/schemas/JsonRpcResponse_for_RpcViewCodeResponse_and_RpcViewCodeError_variant0
        - $ref: >-
            #/components/schemas/JsonRpcResponse_for_RpcViewCodeResponse_and_RpcViewCodeError_variant1
      properties:
        id:
          type: string
        jsonrpc:
          type: string
      required:
        - jsonrpc
        - id
      title: JsonRpcResponse_for_RpcViewCodeResponse_and_RpcViewCodeError
      type: object
    RpcViewCodeRequest:
      oneOf:
        - $ref: '#/components/schemas/RpcViewCodeRequest_variant0'
        - $ref: '#/components/schemas/RpcViewCodeRequest_variant1'
        - $ref: '#/components/schemas/RpcViewCodeRequest_variant2'
      properties:
        account_id:
          $ref: '#/components/schemas/AccountId'
      required:
        - account_id
      title: RpcViewCodeRequest
      type: object
    JsonRpcResponse_for_RpcViewCodeResponse_and_RpcViewCodeError_variant0:
      properties:
        result:
          $ref: '#/components/schemas/RpcViewCodeResponse'
      required:
        - result
      type: object
    JsonRpcResponse_for_RpcViewCodeResponse_and_RpcViewCodeError_variant1:
      properties:
        error:
          $ref: '#/components/schemas/ErrorWrapper_for_RpcViewCodeError'
      required:
        - error
      type: object
    RpcViewCodeRequest_variant0:
      properties:
        block_id:
          $ref: '#/components/schemas/BlockId'
      required:
        - block_id
      type: object
    RpcViewCodeRequest_variant1:
      properties:
        finality:
          $ref: '#/components/schemas/Finality'
      required:
        - finality
      type: object
    RpcViewCodeRequest_variant2:
      properties:
        sync_checkpoint:
          $ref: '#/components/schemas/SyncCheckpoint'
      required:
        - sync_checkpoint
      type: object
    AccountId:
      description: >-
        NEAR Account Identifier.


        This is a unique, syntactically valid, human-readable account identifier
        on the NEAR network.


        [See the crate-level docs for information about
        validation.](index.html#account-id-rules)


        Also see [Error kind precedence](AccountId#error-kind-precedence).


        ## Examples


        ```

        use near_account_id::AccountId;


        let alice: AccountId = "alice.near".parse().unwrap();


        assert!("ƒelicia.near".parse::<AccountId>().is_err()); // (ƒ is not f)

        ```
      title: AccountId
      type: string
    RpcViewCodeResponse:
      description: A view of the contract code.
      properties:
        block_hash:
          $ref: '#/components/schemas/CryptoHash'
        block_height:
          format: uint64
          minimum: 0
          type: integer
        code_base64:
          type: string
        hash:
          $ref: '#/components/schemas/CryptoHash'
      required:
        - code_base64
        - hash
        - block_height
        - block_hash
      type: object
    ErrorWrapper_for_RpcViewCodeError:
      oneOf:
        - $ref: '#/components/schemas/ErrorWrapper_for_RpcViewCodeError_variant0'
        - $ref: '#/components/schemas/ErrorWrapper_for_RpcViewCodeError_variant1'
        - $ref: '#/components/schemas/ErrorWrapper_for_RpcViewCodeError_variant2'
    BlockId:
      anyOf:
        - $ref: '#/components/schemas/BlockId_variant0'
        - $ref: '#/components/schemas/CryptoHash'
    Finality:
      description: Different types of finality.
      enum:
        - optimistic
        - near-final
        - final
      type: string
    SyncCheckpoint:
      enum:
        - genesis
        - earliest_available
      type: string
    CryptoHash:
      type: string
    ErrorWrapper_for_RpcViewCodeError_variant0:
      properties:
        cause:
          $ref: '#/components/schemas/RpcRequestValidationErrorKind'
        name:
          enum:
            - REQUEST_VALIDATION_ERROR
          type: string
      required:
        - name
        - cause
      type: object
    ErrorWrapper_for_RpcViewCodeError_variant1:
      properties:
        cause:
          $ref: '#/components/schemas/RpcViewCodeError'
        name:
          enum:
            - HANDLER_ERROR
          type: string
      required:
        - name
        - cause
      type: object
    ErrorWrapper_for_RpcViewCodeError_variant2:
      properties:
        cause:
          $ref: '#/components/schemas/InternalError'
        name:
          enum:
            - INTERNAL_ERROR
          type: string
      required:
        - name
        - cause
      type: object
    BlockId_variant0:
      format: uint64
      minimum: 0
      title: block_height
      type: integer
    RpcRequestValidationErrorKind:
      oneOf:
        - $ref: '#/components/schemas/RpcRequestValidationErrorKind_variant0'
        - $ref: '#/components/schemas/RpcRequestValidationErrorKind_variant1'
    RpcViewCodeError:
      oneOf:
        - $ref: '#/components/schemas/RpcViewCodeError_variant0'
        - $ref: '#/components/schemas/RpcViewCodeError_variant1'
        - $ref: '#/components/schemas/RpcViewCodeError_variant2'
        - $ref: '#/components/schemas/RpcViewCodeError_variant3'
        - $ref: '#/components/schemas/RpcViewCodeError_variant4'
    InternalError:
      oneOf:
        - $ref: '#/components/schemas/InternalError_variant0'
    RpcRequestValidationErrorKind_variant0:
      properties:
        info:
          properties:
            method_name:
              type: string
          required:
            - method_name
          type: object
        name:
          enum:
            - METHOD_NOT_FOUND
          type: string
      required:
        - name
        - info
      type: object
    RpcRequestValidationErrorKind_variant1:
      properties:
        info:
          properties:
            error_message:
              type: string
          required:
            - error_message
          type: object
        name:
          enum:
            - PARSE_ERROR
          type: string
      required:
        - name
        - info
      type: object
    RpcViewCodeError_variant0:
      properties:
        info:
          properties:
            block_reference:
              $ref: '#/components/schemas/BlockReference'
          required:
            - block_reference
          type: object
        name:
          enum:
            - UNKNOWN_BLOCK
          type: string
      required:
        - name
        - info
      type: object
    RpcViewCodeError_variant1:
      properties:
        info:
          properties:
            block_hash:
              $ref: '#/components/schemas/CryptoHash'
            block_height:
              format: uint64
              minimum: 0
              type: integer
            requested_account_id:
              $ref: '#/components/schemas/AccountId'
          required:
            - requested_account_id
            - block_height
            - block_hash
          type: object
        name:
          enum:
            - INVALID_ACCOUNT
          type: string
      required:
        - name
        - info
      type: object
    RpcViewCodeError_variant2:
      properties:
        info:
          properties:
            block_hash:
              $ref: '#/components/schemas/CryptoHash'
            block_height:
              format: uint64
              minimum: 0
              type: integer
            requested_account_id:
              $ref: '#/components/schemas/AccountId'
          required:
            - requested_account_id
            - block_height
            - block_hash
          type: object
        name:
          enum:
            - UNKNOWN_ACCOUNT
          type: string
      required:
        - name
        - info
      type: object
    RpcViewCodeError_variant3:
      properties:
        info:
          properties:
            block_hash:
              $ref: '#/components/schemas/CryptoHash'
            block_height:
              format: uint64
              minimum: 0
              type: integer
            contract_account_id:
              $ref: '#/components/schemas/AccountId'
          required:
            - contract_account_id
            - block_height
            - block_hash
          type: object
        name:
          enum:
            - NO_CONTRACT_CODE
          type: string
      required:
        - name
        - info
      type: object
    RpcViewCodeError_variant4:
      properties:
        info:
          properties:
            error_message:
              type: string
          required:
            - error_message
          type: object
        name:
          enum:
            - INTERNAL_ERROR
          type: string
      required:
        - name
        - info
      type: object
    InternalError_variant0:
      properties:
        info:
          properties:
            error_message:
              type: string
          required:
            - error_message
          type: object
        name:
          enum:
            - INTERNAL_ERROR
          type: string
      required:
        - name
        - info
      type: object
    BlockReference:
      oneOf:
        - $ref: '#/components/schemas/BlockReference_variant0'
        - $ref: '#/components/schemas/BlockReference_variant1'
        - $ref: '#/components/schemas/BlockReference_variant2'
    BlockReference_variant0:
      additionalProperties: false
      properties:
        block_id:
          $ref: '#/components/schemas/BlockId'
      required:
        - block_id
      type: object
    BlockReference_variant1:
      additionalProperties: false
      properties:
        finality:
          $ref: '#/components/schemas/Finality'
      required:
        - finality
      type: object
    BlockReference_variant2:
      additionalProperties: false
      properties:
        sync_checkpoint:
          $ref: '#/components/schemas/SyncCheckpoint'
      required:
        - sync_checkpoint
      type: object

````